package io.ebeaninternal.dbmigration.model.build;


import io.localtest.BaseTestCase;
import io.ebean.DatabaseFactory;
import io.ebean.config.DatabaseConfig;
import io.ebeaninternal.api.SpiEbeanServer;
import io.ebeaninternal.dbmigration.ddlgeneration.Helper;
import io.ebeaninternal.dbmigration.model.CurrentModel;
import io.ebeaninternal.dbmigration.model.MTable;
import io.ebeaninternal.dbmigration.model.ModelContainer;
import org.junit.jupiter.api.Test;
import org.tests.model.compositekeys.CKEmbId;
import org.tests.model.compositekeys.CKSiteUser;

import java.io.IOException;

import static org.assertj.core.api.Assertions.assertThat;

public class ModelBuild_compound_IdClassTest extends BaseTestCase {

  private SpiEbeanServer createServer() {
    DatabaseConfig config = new DatabaseConfig();
    config.setName("h2");
    config.loadFromProperties();
    config.setName("h2other");
    config.setDdlGenerate(false);
    config.setDdlRun(false);
    config.setDdlExtra(false);
    config.setDefaultServer(false);
    config.setRegister(false);
    config.addClass(CKSiteUser.class);
    config.addClass(CKEmbId.class);
    return (SpiEbeanServer) DatabaseFactory.create(config);
  }

  @Test
  public void test() throws IOException {
    SpiEbeanServer ebeanServer = createServer();
    try {
      CurrentModel currentModel = new CurrentModel(ebeanServer);
      ModelContainer model = currentModel.read();

      MTable parent = model.getTable("cksite_user");
      assertThat(parent).isNotNull();
      assertThat(parent.primaryKeyColumns()).hasSize(2);

      String apply = Helper.asText(this, "/assert/ModelBuild_compound_IdClassTest/apply.sql");

      String createDdl = currentModel.getCreateDdl();
      assertThat(createDdl).startsWith("-- Generated by ebean").endsWith(apply);

    } finally {
      ebeanServer.shutdown();
    }
  }
}
